function o6 = ForwardKinematics(q)
d1 = .4865;
d4 = .600;
d6 = .065;
a1 = .15;
a2 = .475;
a3 = d4 + d6;
% persistent count;
% 
% if isempty(count)
%     count = 0;
% end

% DH parameters
d = [d1; 0; 0; d4; 0; d6];
a = [a1; a2; 0; 0; 0; 0];
o6 =    [a(1)*cos(q(1)) + d(6)*(cos(q(5))*(cos(q(1))*cos(q(2))*cos(q(3)) - cos(q(1))*sin(q(2))*sin(q(3))) - sin(q(5))*(sin(q(1))*sin(q(4)) + cos(q(4))*(cos(q(1))*cos(q(2))*sin(q(3)) + cos(q(1))*cos(q(3))*sin(q(2))))) + d(4)*(cos(q(1))*cos(q(2))*cos(q(3)) - cos(q(1))*sin(q(2))*sin(q(3))) + a(2)*cos(q(1))*sin(q(2));
        a(1)*sin(q(1)) + d(6)*(cos(q(5))*(cos(q(2))*cos(q(3))*sin(q(1)) - sin(q(1))*sin(q(2))*sin(q(3))) + sin(q(5))*(cos(q(1))*sin(q(4)) - cos(q(4))*(cos(q(2))*sin(q(1))*sin(q(3)) + cos(q(3))*sin(q(1))*sin(q(2))))) + d(4)*(cos(q(2))*cos(q(3))*sin(q(1)) - sin(q(1))*sin(q(2))*sin(q(3))) + a(2)*sin(q(1))*sin(q(2));
        d(1) + a(2)*cos(q(2)) - d(4)*(cos(q(2))*sin(q(3)) + cos(q(3))*sin(q(2))) - d(6)*(cos(q(5))*(cos(q(2))*sin(q(3)) + cos(q(3))*sin(q(2))) + cos(q(4))*sin(q(5))*(cos(q(2))*cos(q(3)) - sin(q(2))*sin(q(3))))];
 %initPos = [-0.6500000000e-1 * sin(q(5)) * cos(q(1)) * cos(q(4)) * sin(q(2)) * cos(q(3)) + 0.3600000000e0 * cos(q(1)) * sin(q(2)) - 0.6500000000e-1 * cos(q(1)) * cos(q(5)) * sin(q(2)) * sin(q(3)) - 0.3800000000e0 * cos(q(1)) * sin(q(2)) * sin(q(3)) + 0.7000000000e-1 * cos(q(1)) + 0.3800000000e0 * cos(q(1)) * cos(q(2)) * cos(q(3)) + 0.6500000000e-1 * cos(q(1)) * cos(q(5)) * cos(q(2)) * cos(q(3)) - 0.6500000000e-1 * sin(q(5)) * cos(q(1)) * cos(q(4)) * cos(q(2)) * sin(q(3)) - 0.6500000000e-1 * sin(q(5)) * sin(q(1)) * sin(q(4)) -0.6500000000e-1 * sin(q(5)) * sin(q(1)) * cos(q(4)) * sin(q(2)) * cos(q(3)) + 0.3600000000e0 * sin(q(1)) * sin(q(2)) - 0.6500000000e-1 * sin(q(1)) * cos(q(5)) * sin(q(2)) * sin(q(3)) - 0.3800000000e0 * sin(q(1)) * sin(q(2)) * sin(q(3)) + 0.7000000000e-1 * sin(q(1)) + 0.3800000000e0 * sin(q(1)) * cos(q(2)) * cos(q(3)) + 0.6500000000e-1 * sin(q(1)) * cos(q(5)) * cos(q(2)) * cos(q(3)) - 0.6500000000e-1 * sin(q(5)) * sin(q(1)) * cos(q(4)) * cos(q(2)) * sin(q(3)) + 0.6500000000e-1 * sin(q(5)) * cos(q(1)) * sin(q(4)) -0.6500000000e-1 * cos(q(4)) * sin(q(5)) * cos(q(2)) * cos(q(3)) + 0.3600000000e0 * cos(q(2)) - 0.6500000000e-1 * cos(q(5)) * cos(q(2)) * sin(q(3)) - 0.3800000000e0 * cos(q(2)) * sin(q(3)) - 0.6500000000e-1 * cos(q(5)) * sin(q(2)) * cos(q(3)) - 0.3800000000e0 * sin(q(2)) * cos(q(3)) + 0.3520000000e0 + 0.6500000000e-1 * cos(q(4)) * sin(q(5)) * sin(q(2)) * sin(q(3))]:

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                               3D plot                                   %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
% ae = 0;
% 
% o0 = [0 0 0];
% o1 = [a1 * cos(q(1));
%       a1 * sin(q(1));
%       d1];
% 
% o2 = [a2 * cos(q(1)) * sin(q(2)) + a1 * cos(q(1));
%       a2 * sin(q(1)) * sin(q(2)) + a1 * sin(q(1));
%       d1 + a2 * cos(q(2))];
% 
% o3 = [(cos(q(1)) * (-a3 - 0.1e1 * ae) * sin(q(3)) + a2 * cos(q(1))) * sin(q(2)) + cos(q(3)) * (a3 + ae) * cos(q(2)) * cos(q(1)) + a1 * cos(q(1));
%     ((-a3 - 0.1e1 * ae) * sin(q(1)) * sin(q(3)) + a2 * sin(q(1))) * sin(q(2)) + sin(q(1)) * (a3 + ae) * cos(q(3)) * cos(q(2)) + a1 * sin(q(1));
%     (a2 + (-a3 - 0.1e1 * ae) * sin(q(3))) * cos(q(2)) + d1 + (-a3 - 0.1e1 * ae) * sin(q(2)) * cos(q(3))];
% 
% 
% % kinematic plot of the robot together with local body frames
% figure(100)
% %   plot3([o0(1) o1(1) o2(1) o3(1) ],...
% %       [o0(2) o1(2) o2(2) o3(2) ],... 
% %       [o0(3) o1(3) o2(3) o3(3) ],'b.'), 
% plot3(o0(1),o0(2),o0(3),'m*');
% plot3(o1(1),o1(2),o1(3),'g.');
% plot3(o2(1),o2(2),o2(3),'r.');
% plot3(o3(1),o3(2),o3(3),'b.');
% 
% hold on
% 
% if count == 20
%     plot3([o0(1) o1(1)], [o0(2) o1(2)], [o0(3) o1(3)],'k-');
%     plot3([o1(1) o2(1)], [o1(2) o2(2)], [o1(3) o2(3)],'k-');
%     plot3([o2(1) o3(1)], [o2(2) o3(2)], [o2(3) o3(3)],'k-');
%     count = 0;
% end
% count = count + 1;
% 
% 
% axis equal, grid on;
% xlabel('X[m]'); ylabel('Y [m]'); zlabel('Z [m]');
% view(60,20);

end